<script src="@#file#(fillpoly.js)" type="text/javascript"></script>

<p>U ovoj minilekciji pogledat ćemo princip rada jednog od algoritama za popunjavanje konveksnih poligona koji se temelji na uporabi sken-linije.</p>

<p>Primjer u nastavku prikazuje zaslon rasterske prikazne jedinice dimenzija 20 puta 20 slikovnih elemenata. U uporabi je ekranski koordinatni sustav: slikovni element gore-lijevo ima koordinate (0,0); pozitivna x-os gleda u desno a pozitivna y-os prema dolje.</p>

<p>Na zaslonu su također prikazana i četiri vrha kojima je zadan konveksni poligon te stranice poligona. Vrhovi su redom V1=(10,2), V2=(13,8), V3=(9,17) te V4=(6,11). Četiri vrha definiraju četiri brida: b1 koji ide od V1 do V2, b2 koji ide od V2 do V3, b3 koji ide od V3 do V4 i b4 koji ide od V4 do V1.</p>

  <div width="500" height="500" style="position:relative; width:500px; margin: auto;">
  <canvas id="myCanvas1" width="500" height="500" style="border: 1px solid white;"></canvas>
  </div>
  <script type="text/javascript">
    var vertexes = [{x: 10,y:2, l:"V1"}, {x: 13,y:8, l:"V2"}, {x: 9,y:17, l:"V3"}, {x: 6,y:11, l:"V4"}];
    var brcanvas1 = new RasterDisplay("myCanvas1", 20, 20);
    brcanvas1.fullLines = [
      {x0:vertexes[0].x,y0:vertexes[0].y,x1:vertexes[1].x,y1:vertexes[1].y,c:"#FF0000",l:"b1"},
      {x0:vertexes[1].x,y0:vertexes[1].y,x1:vertexes[2].x,y1:vertexes[2].y,c:"#FF0000",l:"b2"},
      {x0:vertexes[2].x,y0:vertexes[2].y,x1:vertexes[3].x,y1:vertexes[3].y,c:"#FF0000",l:"b3"},
      {x0:vertexes[3].x,y0:vertexes[3].y,x1:vertexes[0].x,y1:vertexes[0].y,c:"#FF0000",l:"b4"}
    ];
    //var alg1 = new FillAlgorithm1(vertexes, brcanvas1, "alg1");
    brcanvas1.points = vertexes;
    brcanvas1.showPointLabels = true;
    brcanvas1.showLineLabels = true;
    brcanvas1.showPoints = true;
    brcanvas1.paint();
  </script>

<p>Želimo razviti algoritam koji će na temelju zadanih vrhova te uz pretpostavku da se radi o konveksnom poligonu obojati čitav poligon.</p>

<p>Evo ideje. Bridove ćemo najprije podijeliti u lijeve i desne. Svaki brid određen je vrhom iz kojeg kreće i vrhom u koji ulazi.</p>

<p>Uz pretpostavku da radimo s ekranskim koordinatnim sustavom, lijeve i desne bridove definirat ćemo na sljedeći način.</p>
<ul><li>Lijevi bridovi su bridovi kod kojih je y-koordinata polaznog vrha veća od y-koordinate dolaznog vrha.</li>
<li>Desni bridovi su bridovi kod kojih je y-koordinata polaznog vrha manja od y-koordinate dolaznog vrha.</li></ul>

<p>Provjerimo ovo na primjeru. Brid b3 kreće iz vrha V3 čije su koordinate (9,17) i ide do vrha V4 čije su koordinate (6,11). Pri tome je y-koordinata polaznog vrha V3 (17) veća od y-koordinate dolaznog vrha V4 (11). Stoga zaključujemo da je brid lijevi i to doista potvrđujemo vizualnom inspekcijom. S druge strane, brid b1 kreće iz vrha V1 čije su koordinate (10,2) i ide do vrha V2 čije su koordinate (13,8). Kako je y-koordinata polaznog vrha V1 (2) manja od y-koordinate dolaznog vrha V2 (8), brid je desni.</p>

<div class="mlNote">
<p>U slučaju da je koordinatni sustav matematički a ne ekranski, definicije lijevih i desnih bridova bi se zamijenile.</p>
</div>

<p>Rezultat podjele bridova na lijeve i desne prikazan je u nastavku. Lijevi bridovi su prikazani plavom bojom i označeni slovom L dok su desni bridovi prikazani crvenom bojom i označeni slovom D.</p>

  <div width="500" height="500" style="position:relative; width:500px; margin: auto;">
  <canvas id="myCanvas2" width="500" height="500" style="border: 1px solid white;"></canvas>
  </div>
  <script type="text/javascript">
    var vertexes2 = [{x: 10,y:2, l:"V1"}, {x: 13,y:8, l:"V2"}, {x: 9,y:17, l:"V3"}, {x: 6,y:11, l:"V4"}];
    var brcanvas2 = new RasterDisplay("myCanvas2", 20, 20);
    brcanvas2.fullLines = [
      {x0:vertexes2[0].x,y0:vertexes2[0].y,x1:vertexes2[1].x,y1:vertexes2[1].y,c:"#FF0000",l:"D"},
      {x0:vertexes2[1].x,y0:vertexes2[1].y,x1:vertexes2[2].x,y1:vertexes2[2].y,c:"#FF0000",l:"D"},
      {x0:vertexes2[2].x,y0:vertexes2[2].y,x1:vertexes2[3].x,y1:vertexes2[3].y,c:"#0000FF",l:"L"},
      {x0:vertexes2[3].x,y0:vertexes2[3].y,x1:vertexes2[0].x,y1:vertexes2[0].y,c:"#0000FF",l:"L"}
    ];
    brcanvas2.points = vertexes2;
    brcanvas2.showPointLabels = true;
    brcanvas2.showLineLabels = true;
    brcanvas2.showPoints = true;
    brcanvas2.paint();
  </script>

<p>Nakon što smo na ovaj način razvrstali bridove, primijetimo da prilikom bojanja poligona sigurno nećemo obojati niti jedan slikovni element čija bi y-koordinata bila manja od najmanje y-koordinate zadanih vrhova ili pak veća od najveće y-koordinate zadanih vrhova (jer bi to značilo da bojamo slikovne elemente koji su iznad ili ispod poligona). Isto tako, sigurno nećemo obojati niti jedan slikovni element čija je x-koordinata manja od najmanje x-koordinate svih zadanih vrhova ili pak veća od najveće x-koordinate svih zadanih vrhova.</p>

<p>Stoga ima smisla proći kroz sve zadane vrhove te odrediti minimalne odnosno maksimalne x i y koordinate. U danom primjeru, x-koordinate zadanih vrhova su redom 10, 13, 9 te 6. Stoga je x<sub>min</sub>=6 a x<sub>max</sub>=13. y-koordinate zadanih vrhova su redom 2, 8, 17 te 11. Stoga je y<sub>min</sub>=2 a y<sub>max</sub>=17.</p>

<p>Sada zaključujemo da će rezultat bojanja zadanog poligona bojati slikovne elemente koji se moraju nalaziti unutar pravokutnika čiji je gornji lijevi ugao u (x<sub>min</sub>,y<sub>min</sub>)=(6,2) a donji desni ugao u (x<sub>max</sub>,y<sub>max</sub>)=(13,17).</p>

<p>Odaberimo sada jedan konkretan y iz raspona [y<sub>min</sub>,y<sub>max</sub>]=[2,17]; npr. odaberimo y=13. Pitamo se sljedeće: koje sve slikovne elemente treba popuniti u retku rastera koji predstavlja slikovne elemente čija je y-koordinata 13.</p>

<p>Zamislimo stoga vodoravni pravac koji je upravo određen jednadžbom y=13. Isti je prikazan na slici u nastavku. Dodatno su prikazani i okomiti pravci koji odgovaraju jednadžbama x=x<sub>min</sub> odnosno x=x<sub>max</sub>.</p>

  <div width="500" height="500" style="position:relative; width:500px; margin: auto;">
  <canvas id="myCanvas3" width="500" height="500" style="border: 1px solid white;"></canvas>
  </div>
  <script type="text/javascript">
    var brcanvas3 = new RasterDisplay("myCanvas3", 20, 20);
    brcanvas3.fullLines = [
      {x0:vertexes2[0].x,y0:vertexes2[0].y,x1:vertexes2[1].x,y1:vertexes2[1].y,c:"#FF0000",l:"b1 (D)"},
      {x0:vertexes2[1].x,y0:vertexes2[1].y,x1:vertexes2[2].x,y1:vertexes2[2].y,c:"#FF0000",l:"b2 (D)"},
      {x0:vertexes2[2].x,y0:vertexes2[2].y,x1:vertexes2[3].x,y1:vertexes2[3].y,c:"#0000FF",l:"b3 (L)"},
      {x0:vertexes2[3].x,y0:vertexes2[3].y,x1:vertexes2[0].x,y1:vertexes2[0].y,c:"#0000FF",l:"b4 (L)"}
    ];
    brcanvas3.points = vertexes2;
    brcanvas3.showPointLabels = true;
    brcanvas3.showLineLabels = true;
    brcanvas3.showPoints = true;

    brcanvas3.vlines=[{x: 6, c: "#0055FF", d: [3,6]}, {x: 13, c: "#0055FF", d: [3,6]}];
    brcanvas3.hlines=[{y: 13, c: "#FF0000", d: [5,5]}];

    brcanvas3.paint();
  </script>

<p>Promotrimo sada sjecišta prikazanog vodoravnog pravca y=13 (sken-linije) sa pravcima na kojima leže lijevi bridovi. Pravac na kojem leži lijevi brid b3 sken-liniju siječe na x=7 dok pravac na kojem leži brid b4 sken-liniju siječe na x=5. Kao x-koordinatu od koje ćemo započeti popunjavanje promatranog retka uvijek biramo najveću od pronađenih koordinata (kažemo da tražimo najdesnije sjecište zrake i svih lijevih bridova). U našem slučaju to je max(5,7)=7.</p>

<p>Promotrimo zatim sjecišta prikazanog vodoravnog pravca y=13 (sken-linije) sa pravcima na kojima leže desni bridovi. Pravac na kojem leži lijevi brid b1 sken-liniju siječe na x=15 dok pravac na kojem leži brid b2 sken-liniju siječe na x=11. Kao x-koordinatu do koje ćemo raditi popunjavanje promatranog retka uvijek biramo najmanju od pronađenih koordinata (kažemo da tražimo najlijevije sjecište zrake i svih desnih bridova). U našem slučaju to je min(15,11)=11.</p>

<p>Stoga bismo u tom retku obojali niz slikovnih elemenata (7,13), (8,13), (9,13), (10,13), (11,13). Drugim riječima, sve slikovne elemente čija je y-koordinata jednaka 13 (promatrana sken-linija) i čije su x-koordinate između najdesnijeg lijevog sjecišta i najlijevijeg desnog sjecišta. Ovo je prikazano na slici u nastavku.</p>

  <div width="500" height="500" style="position:relative; width:500px; margin: auto;">
  <canvas id="myCanvas4" width="500" height="500" style="border: 1px solid white;"></canvas>
  </div>
  <script type="text/javascript">
    var brcanvas4 = new RasterDisplay("myCanvas4", 20, 20);
    brcanvas4.fullLines = [
      {x0:vertexes2[0].x,y0:vertexes2[0].y,x1:vertexes2[1].x,y1:vertexes2[1].y,c:"#FF0000",l:"b1 (D)"},
      {x0:vertexes2[1].x,y0:vertexes2[1].y,x1:vertexes2[2].x,y1:vertexes2[2].y,c:"#FF0000",l:"b2 (D)"},
      {x0:vertexes2[2].x,y0:vertexes2[2].y,x1:vertexes2[3].x,y1:vertexes2[3].y,c:"#0000FF",l:"b3 (L)"},
      {x0:vertexes2[3].x,y0:vertexes2[3].y,x1:vertexes2[0].x,y1:vertexes2[0].y,c:"#0000FF",l:"b4 (L)"}
    ];
    brcanvas4.points = vertexes2;
    brcanvas4.showPointLabels = true;
    brcanvas4.showLineLabels = true;
    brcanvas4.showPoints = true;

    brcanvas4.vlines=[{x: 6, c: "#0055FF", d: [3,6]}, {x: 13, c: "#0055FF", d: [3,6]}];
    brcanvas4.hlines=[{y: 13, c: "#FF0000", d: [5,5]}];

    brcanvas4.pixels[13][7] = 1;
    brcanvas4.pixels[13][8] = 1;
    brcanvas4.pixels[13][9] = 1;
    brcanvas4.pixels[13][10] = 1;
    brcanvas4.pixels[13][11] = 1;
    brcanvas4.paint();
  </script>

<p>Opisani postupak sada naprosto treba primijeniti na svaku od sken-linija koje odgovaraju vodoravnim pravcima od y=y<sub>min</sub> do y=y<sub>max</sub>.</p>

<p>Kako bi se izbjegla potreba da se bridovi eksplicitno sortiraju pa najprije obrađuju svi lijevi a potom svi desni, za svaku ćemo sken-liniju najprije inicijalizirati lijevo sjecište na x<sub>min</sub> a desno na x<sub>max</sub>. Nakon toga ćemo bridove obrađivati redom kojim su zadani vrhovima. Pronaći ćemo sjecište pravca na kojem se nalazi brid i sken-linije. Potom, ako je brid lijevi i ako je pronađeno sjecište desnije od do tada zapamćenog, ažurirat ćemo lijevo sjecište na pronađeno; odnosno, ako je brid desni i ako je pronađeno sjecište lijevije od do tada zapamćenog, ažurirat ćemo desno sjecište na pronađeno.</p>

<p>Detaljniji algoritam te interaktivni prikaz koraka prikazan je na sljedećoj stranici.</p>

